## xxsds-dynamic 1.0~alpha.1%2Bgit20210426.548c6f7

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic


%:
	dh $@

#override_dh_auto_test:
#	obj-$$(dpkg-architecture -qDEB_TARGET_GNU_TYPE)/benchmark -g 1000000 0.01

override_dh_auto_clean:
	dh_auto_clean
	rm -f core

## xxsds-dynamic 1.0~alpha.1+git20210426.548c6f7

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

option(USE_OPENMP "Enable multi-threading" OFF)

# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE)
  message(STATUS "Setting build type to 'Release' as none was specified.")
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
endif()

#set( CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/.. )

project (dynamic)

include(${CMAKE_ROOT}/Modules/ExternalProject.cmake)

# hopscotch_map
ExternalProject_Add(hopscotch_map
  GIT_REPOSITORY "https://github.com/Tessil/hopscotch-map.git"
  BUILD_IN_SOURCE TRUE
  CMAKE_ARGS -DCMAKE_INSTALL_PREFIX:PATH=${INSTALL_DIR} # TODO ADD static build flag
  UPDATE_COMMAND ""
  INSTALL_COMMAND ""
  BUILD_COMMAND ""
  CONFIGURE_COMMAND "")
ExternalProject_Get_property(hopscotch_map INSTALL_DIR)
set(hopscotch_map_INCLUDE "${INSTALL_DIR}/src/hopscotch_map/include/")

include_directories(${PROJECT_SOURCE_DIR}/include)
#include_directories(${PROJECT_SOURCE_DIR}/include/dynamic)
#include_directories(${PROJECT_SOURCE_DIR}/include/dynamic/internal)
#include_directories(${PROJECT_SOURCE_DIR}/include/dynamic/algorithms)
#include_directories(${PROJECT_SOURCE_DIR}/include/dynamic/algorithms/cw-bwt)
include_directories(${INSTALL_DIR}/src/hopscotch_map/include)

message("Building in ${CMAKE_BUILD_TYPE} mode")

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --std=c++11")

if(XXSDS_DYN_MULTI_THREADED)
  find_package(OpenMP REQUIRED)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
endif(XXSDS_DYN_MULTI_THREADED)

set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -g3 -ggdb")
set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -ggdb -Ofast -fstrict-aliasing -DNDEBUG -march=native")
set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -g -ggdb -Ofast -fstrict-aliasing -march=native")

add_executable(debug debug.cpp)
add_executable(rle_lz77_v1 rle_lz77_v1.cpp)
add_executable(rle_lz77_v2 rle_lz77_v2.cpp)
add_executable(h0_lz77 h0_lz77.cpp)
add_executable(rle_bwt rle_bwt.cpp)
add_executable(cw-bwt cw-bwt.cpp)
add_executable(benchmark benchmark.cpp)
add_executable(wm_string wm_string.cpp)

add_dependencies(debug hopscotch_map)
add_dependencies(rle_lz77_v1 hopscotch_map)
add_dependencies(rle_lz77_v2 hopscotch_map)
add_dependencies(h0_lz77 hopscotch_map)
add_dependencies(rle_bwt hopscotch_map)
add_dependencies(cw-bwt hopscotch_map)
add_dependencies(benchmark hopscotch_map)
add_dependencies(wm_string hopscotch_map)

## xxsds-dynamic 1.0~alpha.1+2020072524git5390b6c

=== debian/changelog ===
xxsds-dynamic (1.0~alpha.1+2020072524git5390b6c-3) unstable; urgency=medium

  * Fixed omitted trailer in d/changelog

    Many thanks go to Logan Rosen for spotting that (Closes: #980972).

 -- Steffen Moeller <moeller@debian.org>  Tue, 26 Jan 2021 12:31:31 +0100

xxsds-dynamic (1.0~alpha.1+2020072524git5390b6c-2) unstable; urgency=medium

  * Initial release (Closes: #965272)

    d/copyright now references the contributions by Erik Garrison
    (thanks go to FTPmaster Thorsten for spotting that omission).

 -- Steffen Moeller <moeller@debian.org>  Sun, 13 Sep 2020 19:48:50 +0200
    

xxsds-dynamic (1.0~alpha.1+2020072524git5390b6c-1) UNRELEASED; urgency=medium

  * Initial submission to main.

 -- Steffen Moeller <moeller@debian.org>  Sat, 18 Jul 2020 16:40:45 +0200

=== debian/control ===
Source: xxsds-dynamic
Priority: optional
Maintainer: Steffen Moeller <moeller@debian.org>
Build-Depends: debhelper-compat (= 12),
               cmake,
               libtsl-hopscotch-map-dev
Standards-Version: 4.5.0
Section: libs
Homepage: https://github.com/xxsds/DYNAMIC
Vcs-Browser: https://salsa.debian.org/med-team/dynamic
Vcs-Git: https://salsa.debian.org/med-team/dynamic.git

Package: libxxsds-dynamic-dev
Section: libdevel
Architecture: all
Depends: ${misc:Depends}
Description: succinct and compressed fully-dynamic data structures library
 This library offers space- and time-efficient implementations of some
 basic succinct/compressed dynamic data structures. It only ships header
 files, i.e. is inclusion only.
 .
 DYNAMIC features:
 .
  * A succinct Searchable Partial Sums with Indels (SPSI) structure
    representing a list of integers s_1, s_2, ..., s_m. Space: about
     1.2 * m * ( log(M/m) + log log m )
    bits, where
     M = m + s_1 + s_2 + ... + s_m.
    The structure supports also update operations (i.e. s_i = s_i + delta).
  * A Succinct dynamic bitvector supporting rank/select/access/Indel
    (RSAI) operations. Space: about 1.2 * n bits.
  * A gap-compressed dynamic bitvector supporting rank/select/access/Indel
    operations. Space: about 1.2 * b * ( log(n/b) + log log b ) bits,
    b being the number of bits set and n being the bitvector length. All
    operations take log(b) time.
  * A dynamic sparse vector (of integers) with access/Indel operations.
  * A dynamic string supporting rank/select/access/Indel operations. The
    user can choose at construction time between
    fixed-length/gamma/Huffman encoding of the alphabet. All operations
    take log(n) * log(sigma) time (or log(n) * H0 with Huffman encoding).
  * A run-length encoded dynamic string supporting
    rank/select/access/insert operations (removes are not yet
    implemented). Space: approximately
     R*(1.2 * log(sigma) + 2.4 * (log(n/R)+log log R) )
    bits, where R is the number of runs in the string. All operations
    take log(R) time.
  * A dynamic (left-extend only) entropy/run-length compressed BWT
  * A dynamic (left-extend only) entropy/run-length compressed
    FM-index. This structure consists in the above BWT + a dynamic suffix
    array sampling
 .
 Algorithms
 .
  * Two algorithms to build LZ77 in repetition-aware RAM working
    space. Both algorithms use a run-length encoded BWT with sparse
    Suffix array sampling. The first algorithm stores 2 SA samples per
    BWT run. The second algorithm (much more space efficient) stores
    1 SA sample per LZ factor. From the papers "Computing LZ77 in
    Run-Compressed Space", Alberto Policriti and Nicola Prezza, DCC2016
    and " LZ77 Computation Based on the Run-Length Encoded BWT", Alberto
    Policriti and Nicola Prezza (Algorithmica)
  * An algorithm to build the BWT in run-compressed space
  * An algorithm to build LZ77 in nH0(2+o(1)) space and n * log n *
    H0 time. From the paper "Fast Online Lempel-Ziv Factorization in
    Compressed Space", Alberto Policriti and Nicola Prezza, SPIRE2015
  * An algorithm to build the BWT in high-order compressed space. The
    algorithm runs in O(n * H_k * log log n) average-case time (e.g. good
    for DNA) and O(n * H_k * log n) worst-case time. From the paper
    "Average linear time and compressed space construction of the
    Burrows-Wheeler transform" Policriti A., Gigante N. and Prezza N.,
    LATA 2015 (the paper discusses a theoretically faster variant)
 .
 The SPSI structure is the building block on which all other structures
 are based. This structure is implemented with cache-efficient B-trees.

=== debian/rules ===
--- 
+++ 
@@ -3,6 +3,7 @@
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
+export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 
 %:

=== debian/watch ===
version=4
opts="uversionmangle=s/-/~/" \
   https://github.com/xxsds/DYNAMIC/tags \
   (?:.*?/)?v(\d\.[0-9alphbetgm.-]*)\.tar\.gz

## xxsds-dynamic 1.0~alpha.1+git20210426.548c6f7

=== debian/changelog ===
xxsds-dynamic (1.0~alpha.1+git20210426.548c6f7-2) unstable; urgency=medium

  * Team Upload.
  * Adjust useOurHopscotchMap.patch to be compatible with existing hopscotch
    Closes: #1042340
  * Update d/u/metadata
  * Bump Standards-Version to 4.6.2 (no changes needed)
  * Update copyright years

 -- Nilesh Patra <nilesh@debian.org>  Fri, 25 Aug 2023 12:51:19 +0530

xxsds-dynamic (1.0~alpha.1+git20210426.548c6f7-1) unstable; urgency=medium

  * Team upload.
  * Fix Vcs fields
  * Debian Med team maintenance
  * Use git mode in watch file
  * Standards-Version: 4.6.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
  * Avoid explicitly specifying -Wl,--as-needed linker flag.
  * Apply multi-arch hints.
    + libxxsds-dynamic-dev: Add Multi-Arch: foreign.

 -- Andreas Tille <tille@debian.org>  Mon, 13 Dec 2021 20:07:49 +0100

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,22 @@
 Source: xxsds-dynamic
 Priority: optional
-Maintainer: Steffen Moeller <moeller@debian.org>
-Build-Depends: debhelper-compat (= 12),
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Uploaders: Steffen Moeller <moeller@debian.org>
+Build-Depends: debhelper-compat (= 13),
                cmake,
                libtsl-hopscotch-map-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Section: libs
+Vcs-Browser: https://salsa.debian.org/med-team/xxsds-dynamic
+Vcs-Git: https://salsa.debian.org/med-team/xxsds-dynamic.git
 Homepage: https://github.com/xxsds/DYNAMIC
-Vcs-Browser: https://salsa.debian.org/med-team/dynamic
-Vcs-Git: https://salsa.debian.org/med-team/dynamic.git
+Rules-Requires-Root: no
 
 Package: libxxsds-dynamic-dev
 Section: libdevel
 Architecture: all
 Depends: ${misc:Depends}
+Multi-Arch: foreign
 Description: succinct and compressed fully-dynamic data structures library
  This library offers space- and time-efficient implementations of some
  basic succinct/compressed dynamic data structures. It only ships header

=== debian/watch ===
version=4

opts="uversionmangle=s/-/~/,mode=git,pretty=1.0~alpha.1+git%cd.%h" \
    https://github.com/xxsds/DYNAMIC.git HEAD

#opts="uversionmangle=s/-/~/" \
#   https://github.com/xxsds/DYNAMIC/tags \
#   (?:.*?/)?v(\d\.[0-9alphbetgm.-]*)\.tar\.gz
